'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dynamoDb = require('./dynamo-db');

var _dynamoDb2 = _interopRequireDefault(_dynamoDb);

var _helpers = require('./helpers');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var DynamoTable = function () {
  function DynamoTable(_ref) {
    var _ref$tableName = _ref.tableName,
        tableName = _ref$tableName === undefined ? '' : _ref$tableName,
        _ref$schema = _ref.schema,
        schema = _ref$schema === undefined ? {} : _ref$schema,
        _ref$primaryKey = _ref.primaryKey,
        primaryKey = _ref$primaryKey === undefined ? '' : _ref$primaryKey;

    _classCallCheck(this, DynamoTable);

    this.DynamoDB = _dynamoDb2.default;
    this.tableName = tableName;
    this.schema = schema;
    this.primaryKey = primaryKey;
  }

  _createClass(DynamoTable, [{
    key: 'setTableName',
    value: function setTableName(tableName) {
      if (!tableName) {
        throw new Error('tableName needs to be set');
      }
      this.tableName = tableName;

      return this;
    }
  }, {
    key: 'setSchema',
    value: function setSchema(schema) {
      if (!schema) {
        throw new Error('schema needs to be set');
      }
      this.schema = schema;

      return this;
    }
  }, {
    key: 'setPrimaryKey',
    value: function setPrimaryKey(primaryKey) {
      if (!primaryKey) {
        throw new Error('primaryKey needs to be set');
      }
      this.primaryKey = primaryKey;

      return this;
    }
  }, {
    key: 'add',
    value: function () {
      var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(item) {
        var _this = this;

        var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                this.validateInstance();

                return _context.abrupt('return', new Promise(function (resolve, reject) {
                  return _dynamoDb2.default.putItem(_extends({
                    TableName: _this.tableName,
                    ReturnValues: 'NONE',
                    Item: (0, _helpers.buildDBItem)(item, _this.schema)
                  }, options), function (err, res) {
                    if (err) {
                      reject(err);
                    } else {
                      resolve(res);
                    }
                  });
                }));

              case 2:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function add(_x2) {
        return _ref2.apply(this, arguments);
      }

      return add;
    }()
  }, {
    key: 'delete',
    value: function () {
      var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(itemId) {
        var _this2 = this;

        var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                this.validateInstance();

                return _context2.abrupt('return', new Promise(function (resolve, reject) {
                  return _dynamoDb2.default.deleteItem(_extends({
                    TableName: _this2.tableName,
                    Key: _this2.buildPrimaryKey(itemId)
                  }, options), function (err, res) {
                    if (err) {
                      reject(err);
                    } else {
                      resolve(res);
                    }
                  });
                }));

              case 2:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function _delete(_x4) {
        return _ref3.apply(this, arguments);
      }

      return _delete;
    }()
  }, {
    key: 'get',
    value: function () {
      var _ref4 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(itemId) {
        var _this3 = this;

        var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                this.validateInstance();

                return _context3.abrupt('return', new Promise(function (resolve, reject) {
                  return _dynamoDb2.default.getItem(_extends({
                    TableName: _this3.tableName,
                    Key: _this3.buildPrimaryKey(itemId)
                  }, options), function (err, res) {
                    if (err) {
                      reject(err);
                    } else {
                      resolve((0, _helpers.parseDBItem)(res.Item || {}, _this3.schema));
                    }
                  });
                }));

              case 2:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function get(_x6) {
        return _ref4.apply(this, arguments);
      }

      return get;
    }()
  }, {
    key: 'update',
    value: function () {
      var _ref5 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(itemId, item) {
        var _this4 = this;

        var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
        var Item, keys, keyCounter, keyMap, updateExpression;
        return regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                this.validateInstance();

                Item = (0, _helpers.buildDBItem)(item, this.schema);
                keys = Object.keys(item);
                keyCounter = 96;
                keyMap = keys.reduce(function (acc, key) {
                  keyCounter++;

                  return _extends({}, acc, _defineProperty({}, key, String.fromCharCode(keyCounter).toLowerCase()));
                }, {});
                updateExpression = keys.reduce(function (acc, key) {
                  acc.push('#' + keyMap[key].toUpperCase() + ' = :' + keyMap[key]);

                  return acc;
                }, []).join(', ');
                return _context4.abrupt('return', new Promise(function (resolve, reject) {
                  return _dynamoDb2.default.updateItem(_extends({
                    TableName: _this4.tableName,
                    Key: _this4.buildPrimaryKey(itemId),
                    ExpressionAttributeNames: keys.reduce(function (acc, key) {
                      return _extends({}, acc, _defineProperty({}, '#' + keyMap[key].toUpperCase(), key));
                    }, {}),
                    ExpressionAttributeValues: keys.reduce(function (acc, key) {
                      return _extends({}, acc, _defineProperty({}, ':' + keyMap[key], Item[key]));
                    }, {}),
                    ReturnValues: 'ALL_NEW',
                    UpdateExpression: 'SET ' + updateExpression
                  }, options), function (err, res) {
                    if (err) {
                      reject(err);
                    } else {
                      resolve(res);
                    }
                  });
                }));

              case 7:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function update(_x8, _x9) {
        return _ref5.apply(this, arguments);
      }

      return update;
    }()
  }, {
    key: 'validateInstance',
    value: function validateInstance() {
      if (!this.tableName || !this.schema || !this.primaryKey) {
        throw new Error('require tableName, schema, and primaryKey to make requests to DynamoDB');
      } else if (!this.schema[this.primaryKey]) {
        throw new Error('Primary key needs to exist within schema');
      } else {
        return true;
      }
    }
  }, {
    key: 'buildPrimaryKey',
    value: function buildPrimaryKey(itemId) {
      return _defineProperty({}, this.primaryKey, _defineProperty({}, this.schema[this.primaryKey], itemId));
    }
  }]);

  return DynamoTable;
}();

exports.default = DynamoTable;